/* use jd.h */
/* ----------------------------------------------------------------
 * weekday returns a string for 3-letter name of the day of the week
 * algorithm: Explanatory Supplement, p. 603-604
 * but note that indexing here is 0-6, not 1-7, Sunday - Saturday 
 * used jd.h
 * ----------------------------------------------------------------
  */

char *weekday( jd )
long jd; 
{
  static char *dayname[7];
  int i;

  dayname[0] = "Sun";
  dayname[1] = "Mon";
  dayname[2] = "Tue";
  dayname[3] = "Wed";
  dayname[4] = "Thu";
  dayname[5] = "Fri";
  dayname[6] = "Sat";
  
  i = weekdayNumber( jd ); 

  return dayname[i];

}

char *xWeekday( jdate )
double jdate;
{
  static char *dayname[7];
  long jd, i;

  dayname[0] = "Sun";
  dayname[1] = "Mon";
  dayname[2] = "Tue";
  dayname[3] = "Wed";
  dayname[4] = "Thu";
  dayname[5] = "Fri";
  dayname[6] = "Sat";
  
  jd = jdate + 0.5;   /* the integer julian date at noon on the day of interest */

  i = weekdayNumber( jd ); 

  return dayname[i];

}



/* ----------------------------------------------------------------
 * the algorithm from the Explnatory Supplement:
 * ----------------------------------------------------------------
 */

int
weekdayNumber( jd )
long jd;
{
  long i;

  
  i = jd - 7*((jd+1)/7) + 2;

  i -= 1;     /* shift from 1-7 to 0-6 indexing */

  if (i < 0 || i > 6)
  {
    printf(" something is very bad, i %d out of range in weekday(); reset to zero; jd = %ld \n", i, jd );
    i = 0;
  }

  return i; 

}
